ModuleInfo "Version: 2.15"
ModuleInfo "Author: gman"
ModuleInfo "License: Public Domain"
ModuleInfo "Credit: This mod makes use if the ZLib C functions by Gilles Vollant (http://www.winimage.com/zLibDll/unzip.html)"
ModuleInfo "Credit: This mod was initially created by Thomas Mayer"
ModuleInfo "Credit: Smurftra for his DateTime functions (http://www.blitzbasic.com/codearcs/codearcs.php?code=1726)"
ModuleInfo "Credit: JoshK (and others) for the CRC functions (http://www.blitzmax.com/Community/posts.php?topic=97273)"
ModuleInfo "History: 2005/11/14 GG - updated to be compatible with BMAX v1.12"
ModuleInfo "History: 2005/12/05 GG - updated to be compatible with BMAX v1.14"
ModuleInfo "History: 2005/12/07 GG - created new ZipRamStream and updated extractfile() to use new stream"
ModuleInfo "History: 2005/12/14 GG - fixed bug in readFileList() where it was trying to read from an empty (new) file"
ModuleInfo "History: 2005/12/14 GG - changed to SuperStrict and fixed all missing declarations"
ModuleInfo "History: 2005/12/17 GG - added clearing of filename and filelist in closezip()"
ModuleInfo "History: 2006/07/15 GG - added datetime stamps to zipped file information (reported by Grisu)"
ModuleInfo "History: 2006/07/15 GG - fixed filecount not counting added files (reported by Lomat)"
ModuleInfo "History: 2006/07/15 GG - added AddStream() method to allow adding a stream as a file"
ModuleInfo "History: 2007/07/17 GG - changed to gman.ZipEngine"
ModuleInfo "History: 2009/02/10 GG - fixed AddStream() bug found by peterigz"
ModuleInfo "History: 2009/02/15 GG - converted to scan central headers instead of local headers"
ModuleInfo "History: 2009/02/15 GG - Added stream wrapper for ZipEngine"
ModuleInfo "History: 2009/02/27 GG - Updated central directory scan routine to be faster"
ModuleInfo "History: 2010/06/30 GG - Fixed issue with AddFileToDest where destination filename was not being used"
ModuleInfo "History: 2010/07/26 GG - Fixed issue with extracting directories to disk"
ModuleInfo "History: 2010/07/26 GG - Fixed issue with trying to extract to an in use file.  Added return value to ExtractFileToDisk."
ModuleInfo "History: 2010/07/27 GG - Added timestamping of extracted files."
ModuleInfo "History: 2010/07/28 GG - Changed to use utime instead of _utime to support MacOSX."
ModuleInfo "History: 2012/03/23 GG - Fixed issue with CRC check found by JoshK."
import brl.blitz
import pub.zlib
import brl.basic
import brl.system
import brl.retro
import brl.map
crc_init%()="gman_zipengine_crc_init"
GetStreamCRC32%(stream:brl.stream.TStream)="gman_zipengine_GetStreamCRC32"
APPEND_STATUS_CREATE%=0
APPEND_STATUS_CREATEAFTER%=1
APPEND_STATUS_ADDINZIP%=2
Z_DEFLATED%=8
Z_NO_COMPRESSION%=0
Z_BEST_SPEED%=1
Z_BEST_COMPRESSION%=9
Z_DEFAULT_COMPRESSION%=-1
UNZ_CASE_CHECK%=1
UNZ_NO_CASE_CHECK%=2
UNZ_OK%=0
UNZ_END_OF_LIST_OF_FILE%=-100
UNZ_EOF%=0
UNZ_PARAMERROR%=-102
UNZ_BADZIPFILE%=-103
UNZ_INTERNALERROR%=-104
UNZ_CRCERROR%=-105
ZLIB_FILEFUNC_SEEK_CUR%=1
ZLIB_FILEFUNC_SEEK_END%=2
ZLIB_FILEFUNC_SEEK_SET%=0
ZLIB_FILEFUNC_MODE_READ%=1
ZLIB_FILEFUNC_MODE_WRITE%=2
ZLIB_FILEFUNC_MODE_READWRITEFILTER%=3
ZLIB_FILEFUNC_MODE_EXISTING%=4
ZLIB_FILEFUNC_MODE_CREATE%=8
bmx_fill_fopen_filefunc%(bind_bmx_open_file_func@*(opaque@*,filename@*,mode%),bind_bmx_read_file_func%%(opaque@*,stream@*,buf@*,size%%),bind_bmx_write_file_func%%(opaque@*,stream@*,buf@*,size%%),bind_bmx_tell_file_func%%(opaque@*,stream@*),bind_bmx_seek_file_func%%(stream@*,offset%%,origin%),bind_bmx_close_file_func%(opaque@*,stream@*),bind_bmx_error_file_func%(opaque@*,stream@*))="bmx_fill_fopen_filefunc"
zipOpen@*(fileName$z,append%)="zipOpen"
zipClose%(zipFilePtr@*,archiveName$z)="zipClose"
zipOpenNewFileInZip%(zipFilePtr@*,fileName$z,zip_fileinfo@*,extrafield_local@*,size_extrafield_local%,extrafield_global@*,size_extrafield_global%,comment$z,compressionMethod%,level%)="zipOpenNewFileInZip"
zipOpenNewFileWithPassword%(zipFilePtr@*,fileName$z,zip_fileinfo@*,extrafield_local@*,size_extrafield_local%,extrafield_global@*,size_extrafield_global%,comment$z,compressionMethod%,level%,password$z,crc%%)="zipOpenNewFileWithPassword"
zipWriteInFileInZip%(zipFilePtr@*,buffer@*,bufferLength%)="zipWriteInFileInZip"
zipWriteInFileInZipUTF8%(zipFilePtr@*,buffer@*,bufferLength%)="zipWriteInFileInZipUTF8"
unzOpen@*(zipFileName$z)="unzOpen"
bmx_unzOpen2@*(zipFileName$z)="bmx_unzOpen2"
unzLocateFile%(zipFilePtr@*,fileName$z,caseCheck%)="unzLocateFile"
unzOpenCurrentFile%(zipFilePtr@*)="unzOpenCurrentFile"
unzOpenCurrentFilePassword%(file@*,password$z)="unzOpenCurrentFilePassword"
unzGetCurrentFileSize%(zipFilePtr@*)="unzGetCurrentFileSize"
unzReadCurrentFile%(zipFilePtr@*,buffer@*,size%)="unzReadCurrentFile"
unzCloseCurrentFile%(zipFilePtr@*)="unzCloseCurrentFile"
unzClose%(zipFilePtr@*)="unzClose"
unztell%(zipFilePtr@*)="unztell"
unzeof%(zipFilePtr@*)="unzeof"
unzGetOffset%%(zipFilePtr@*)="unzGetOffset"
unzSetOffset%(zipFilePtr@*,pos%%)="unzSetOffset"
bmx_set_file_mod_date_time%(filename$z,hours%,mins%,secs%,day%,month%,year%)="bmx_set_file_mod_date_time"
ZipFile^brl.blitz.Object{
.m_name$&
.m_zipFileList:TZipFileList&
-New%()="_gman_zipengine_ZipFile_New"
-Delete%()="_gman_zipengine_ZipFile_Delete"
-readFileList%()="_gman_zipengine_ZipFile_readFileList"
-clearFileList%()="_gman_zipengine_ZipFile_clearFileList"
-getFileCount%()="_gman_zipengine_ZipFile_getFileCount"
-setName%(zipName$)="_gman_zipengine_ZipFile_setName"
-getName$()="_gman_zipengine_ZipFile_getName"
-getFileInfo:SZipFileEntry(index%)="_gman_zipengine_ZipFile_getFileInfo"
-getFileInfoByName:SZipFileEntry(simpleFilename$)="_gman_zipengine_ZipFile_getFileInfoByName"
}A="gman_zipengine_ZipFile"
ZipWriter^ZipFile{
.m_zipFile@*&
.m_compressionLevel%&
-New%()="_gman_zipengine_ZipWriter_New"
-Delete%()="_gman_zipengine_ZipWriter_Delete"
-OpenZip%(name$,append%)="_gman_zipengine_ZipWriter_OpenZip"
-SetCompressionLevel%(level%)="_gman_zipengine_ZipWriter_SetCompressionLevel"
-AddFile%(fileName$,password$=$"")="_gman_zipengine_ZipWriter_AddFile"
-AddFileToDest%(fileName$,destFile$,password$=$"")="_gman_zipengine_ZipWriter_AddFileToDest"
-AddStream%(data:brl.stream.TStream,fileName$,password$=$"")="_gman_zipengine_ZipWriter_AddStream"
-CloseZip%(description$=$"")="_gman_zipengine_ZipWriter_CloseZip"
}="gman_zipengine_ZipWriter"
ZipReader^ZipFile{
.m_zipFile@*&
-New%()="_gman_zipengine_ZipReader_New"
-Delete%()="_gman_zipengine_ZipReader_Delete"
-OpenZip%(name$)="_gman_zipengine_ZipReader_OpenZip"
-ExtractFile:brl.ramstream.TRamStream(fileName$,caseSensitive%=0,password$=$"")="_gman_zipengine_ZipReader_ExtractFile"
-ExtractFileToDisk%(fileName$,outputFileName$,caseSensitive%=0,password$=$"")="_gman_zipengine_ZipReader_ExtractFileToDisk"
-CloseZip%()="_gman_zipengine_ZipReader_CloseZip"
}="gman_zipengine_ZipReader"
ZipRamStream^brl.ramstream.TRamStream{
._data@&[]&
-New%()="_gman_zipengine_ZipRamStream_New"
-Delete%()="_gman_zipengine_ZipRamStream_Delete"
+ZCreate:brl.ramstream.TRamStream(size%,readable%,writeable%)="_gman_zipengine_ZipRamStream_ZCreate"
}="gman_zipengine_ZipRamStream"
TZipFileList^brl.blitz.Object{
.zipFile:brl.stream.TStream&
.FileList:brl.linkedlist.TList&
.IgnoreCase%&
.IgnorePaths%&
-New%()="_gman_zipengine_TZipFileList_New"
-Delete%()="_gman_zipengine_TZipFileList_Delete"
+Create:TZipFileList(file:brl.stream.TStream,bIgnoreCase%,bIgnorePaths%)="_gman_zipengine_TZipFileList_Create"
-getFileCount%()="_gman_zipengine_TZipFileList_getFileCount"
-getFileInfo:SZipFileEntry(index%)="_gman_zipengine_TZipFileList_getFileInfo"
-findFile:SZipFileEntry(simpleFilename$)="_gman_zipengine_TZipFileList_findFile"
-ScanCentralHeader%()="_gman_zipengine_TZipFileList_ScanCentralHeader"
-extractFilename%(entry:SZipFileEntry)="_gman_zipengine_TZipFileList_extractFilename"
-deletePathFromFilename%(filename$ Var)="_gman_zipengine_TZipFileList_deletePathFromFilename"
}="gman_zipengine_TZipFileList"
ZIP_INFO_IN_DATA_DESCRIPTOR@@=8
tm^brl.blitz.Object{
.tm_sec%&
.tm_min%&
.tm_hour%&
.tm_mday%&
.tm_mon%&
.tm_year%&
.tm_wday%&
.tm_yday%&
.tm_isdst%&
-New%()="_gman_zipengine_tm_New"
-Delete%()="_gman_zipengine_tm_Delete"
}="gman_zipengine_tm"
tm_zip^brl.blitz.Object{
.tm_sec%&
.tm_min%&
.tm_hour%&
.tm_mday%&
.tm_mon%&
.tm_year%&
-New%()="_gman_zipengine_tm_zip_New"
-Delete%()="_gman_zipengine_tm_zip_Delete"
}="gman_zipengine_tm_zip"
zip_fileinfo^brl.blitz.Object{
.tmz_date:tm_zip&
.dosDate%%&
.internal_fa%%&
.external_fa%%&
-New%()="_gman_zipengine_zip_fileinfo_New"
-Delete%()="_gman_zipengine_zip_fileinfo_Delete"
-getBank:brl.bank.TBank()="_gman_zipengine_zip_fileinfo_getBank"
}="gman_zipengine_zip_fileinfo"
SZIPFileDataDescriptor^brl.blitz.Object{
.CRC32%&
.CompressedSize%&
.UncompressedSize%&
-New%()="_gman_zipengine_SZIPFileDataDescriptor_New"
-Delete%()="_gman_zipengine_SZIPFileDataDescriptor_Delete"
-fill%(data:brl.stream.TStream)="_gman_zipengine_SZIPFileDataDescriptor_fill"
}="gman_zipengine_SZIPFileDataDescriptor"
SZIPCentralFileHeader^brl.blitz.Object{
.Sig%&
.VersionMadeBy@@&
.VersionToExtract@@&
.GeneralBitFlag@@&
.CompressionMethod@@&
.LastModFileTime@@&
.LastModFileDate@@&
.DataDescriptor:SZIPFileDataDescriptor&
.FilenameLength@@&
.ExtraFieldLength@@&
.CommentLength@@&
.DiskNumStart@@&
.InternalFileAttributes@@&
.ExternalFileAttributes%&
.RelativeOffsetOfLocalHeader%&
.FileName$&
.ExtraField$&
.FileComment$&
.LastModDateTime:tm&
-New%()="_gman_zipengine_SZIPCentralFileHeader_New"
-Delete%()="_gman_zipengine_SZIPCentralFileHeader_Delete"
-fill%(data:brl.stream.TStream)="_gman_zipengine_SZIPCentralFileHeader_fill"
}="gman_zipengine_SZIPCentralFileHeader"
SZipFileEntry^brl.blitz.Object{
.zipFileName$&
.simpleFileName$&
.path$&
.header:SZIPCentralFileHeader&
-New%()="_gman_zipengine_SZipFileEntry_New"
-Delete%()="_gman_zipengine_SZipFileEntry_Delete"
+Create:SZipFileEntry()="_gman_zipengine_SZipFileEntry_Create"
-IsDirectory%()="_gman_zipengine_SZipFileEntry_IsDirectory"
-Less%(other:SZipFileEntry)="_gman_zipengine_SZipFileEntry_Less"
-EqEq%(other:SZipFileEntry)="_gman_zipengine_SZipFileEntry_EqEq"
-Compare%(other:Object)="_gman_zipengine_SZipFileEntry_Compare"
}="gman_zipengine_SZipFileEntry"
TZipEngineStreamFactory^brl.stream.TStreamFactory{
-New%()="_gman_zipengine_TZipEngineStreamFactory_New"
-Delete%()="_gman_zipengine_TZipEngineStreamFactory_Delete"
-CreateStream:brl.stream.TStream(url:Object,proto$,path$,readable%,writeable%)="_gman_zipengine_TZipEngineStreamFactory_CreateStream"
}="gman_zipengine_TZipEngineStreamFactory"
TZipEStream^brl.stream.TStream{
.filename$&
.case_sensitive%&
.password$&
.file_size%&
.reader:ZipReader&
-New%()="_gman_zipengine_TZipEStream_New"
-Delete%()="_gman_zipengine_TZipEStream_Delete"
+Create:TZipEStream(zipfile$,filename$,case_sensitive%=0,password$=$"")="_gman_zipengine_TZipEStream_Create"
-find_file%(perform_test_seek%=0)="_gman_zipengine_TZipEStream_find_file"
-Eof%()="_gman_zipengine_TZipEStream_Eof"
-Pos%()="_gman_zipengine_TZipEStream_Pos"
-Size%()="_gman_zipengine_TZipEStream_Size"
-Seek%(pos%)="_gman_zipengine_TZipEStream_Seek"
-Flush%()="_gman_zipengine_TZipEStream_Flush"
-Close%()="_gman_zipengine_TZipEStream_Close"
-Read%(buf@*,count%)="_gman_zipengine_TZipEStream_Read"
}="gman_zipengine_TZipEStream"
crc_table%&[]&=mem:p("gman_zipengine_crc_table")
